#include "bits/stdc++.h"
#include "testlib.h"
#define puba push_back
#define mapa make_pair
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const double PI = atan2(0, -1);
const int MAXN = 300, MAXL = 300;

char field[MAXN][MAXN];

int dx[4] = {-1, 0, 1, 0};
int dy[4] = {0, -1, 0, 1};

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    assert(argc >= 6);

    int n = atoi(argv[1]);
    int m = atoi(argv[2]);
    int step = atoi(argv[3]);
    int l = atoi(argv[4]);
    int percent = atoi(argv[5]);

    assert(l % 2 == 0 && (n > 1 || m > 1));
    assert(step <= 26);

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            field[i][j] = 'a' + (i + j) % step;
        }
    }

    int up = rnd.next(max(0, l / 2 - m + 1), min(l / 2, n - 1)), down = up;
    int left = l / 2 - up, right = left;

    int add_up = rnd.next(min(5, up), min(max(l / 15, 5), up)); up -= add_up;
    int add_down = rnd.next(min(5, down), min(max(l / 15, 5), down)); down -= add_down;
    int add_left = rnd.next(min(5, left), min(max(l / 15, 5), left)); left -= add_left;
    int add_right = rnd.next(min(5, right), min(max(l / 15, 5), right)); right -= add_right;

    //cerr << add_up << " " << add_down << " " << add_left << " " << add_right << endl;

    vector<int> arrd;

    int tmp = rnd.next(0, up);
    for (int i = 0; i < tmp; ++i) {
        arrd.puba(0);
    }
    up -= tmp;
    
    tmp = rnd.next(0, left);
    for (int i = 0; i < tmp; ++i) {
        arrd.puba(1);
    }
    left -= tmp;

    shuffle(arrd.begin(), arrd.end());

    auto from = szof(arrd);


    tmp = up;
    for (int i = 0; i < tmp; ++i) {
        arrd.puba(0);
    }
    
    tmp = rnd.next(0, right);
    for (int i = 0; i < tmp; ++i) {
        arrd.puba(3);
    }
    right -= tmp;

    shuffle(arrd.begin() + from, arrd.end());
    from = szof(arrd);
    

    tmp = rnd.next(0, down);
    for (int i = 0; i < tmp; ++i) {
        arrd.puba(2);
    }
    down -= tmp;
    
    tmp = right;
    for (int i = 0; i < tmp; ++i) {
        arrd.puba(3);
    }

    shuffle(arrd.begin() + from, arrd.end());
    from = szof(arrd);


    tmp = down;
    for (int i = 0; i < tmp; ++i) {
        arrd.puba(2);
    }
    
    tmp = left;
    for (int i = 0; i < tmp; ++i) {
        arrd.puba(1);
    }

    shuffle(arrd.begin() + from, arrd.end());
    from = szof(arrd);

    for (int i = 0; i < add_up; ++i) {
        int pos = rnd.next(0, szof(arrd));
        arrd.puba(0);
        rotate(arrd.begin() + pos, arrd.end() - 1, arrd.end());
    }

    for (int i = 0; i < add_down; ++i) {
        int pos = rnd.next(0, szof(arrd));
        arrd.puba(2);
        rotate(arrd.begin() + pos, arrd.end() - 1, arrd.end());
    }
    
    for (int i = 0; i < add_left; ++i) {
        int pos = rnd.next(0, szof(arrd));
        arrd.puba(1);
        rotate(arrd.begin() + pos, arrd.end() - 1, arrd.end());
    }

    for (int i = 0; i < add_right; ++i) {
        int pos = rnd.next(0, szof(arrd));
        arrd.puba(3);
        rotate(arrd.begin() + pos, arrd.end() - 1, arrd.end());
    }
    

    vector<pii> arrpos = {{0, 0}};
    int minx = 0, maxx = 0, miny = 0, maxy = 0;
    for (int d: arrd) {
        arrpos.puba({arrpos.back().ff + dx[d], arrpos.back().ss + dy[d]});
        minx = min(minx, arrpos.back().ff);
        maxx = max(maxx, arrpos.back().ff);
        miny = min(miny, arrpos.back().ss);
        maxy = max(maxy, arrpos.back().ss);
    }

    //cerr << minx << " " << maxx << " " << miny << " " << maxy << endl;
    
    assert(arrpos.back() == make_pair(0, 0));

    arrpos.pop_back();

    int sx = rnd.next(-minx, n - maxx - 1);
    int sy = rnd.next(-miny, m - maxy - 1);

    for (auto& p: arrpos) {
        //cerr << sx << " " << sy << endl;
        p.ff += sx;
        p.ss += sy;
    }

    /*
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cerr << field[i][j];
        }
        cerr << endl;
    }*/

    vector<pii> to_spoil = arrpos;
    shuffle(bend(to_spoil));

    for (int i = 0; i < max(l * percent / 100, 1); ++i) {
        field[to_spoil[i].ff][to_spoil[i].ss] = 'a' + rnd.next(0, 25);
    }

    cout << n << " " << m << " " << l << "\n";

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << field[i][j];
        }
        cout << endl;
    }

    string res = "";

    for (auto p: arrpos) {
        res += field[p.ff][p.ss];
    }

    bool flag = false;
    if (argc >= 7) {
        flag = atoi(argv[6]);
    }

    if (flag) {
        /*
        int tmp = 1;
        for (int i = 0; i < tmp; ++i) {
            res[rnd.next(0, szof(res) - 1)] = 'a' + rnd.next(0, 25);
        }*/
        if (flag == 1) {
            res[(int) (szof(res) * 0.99)] = 'a' + rnd.next(0, 25); 
        } else if (flag == 2) {
            res[(int) (szof(res) * 0.01)] = 'a' + rnd.next(0, 25); 
        } else {
            res[(int) (szof(res) / 2)] = 'a' + rnd.next(0, 25); 
        }
    }


    cout << res << "\n";

    return 0;
}