#include "bits/stdc++.h"
#define puba push_back
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const double PI = atan2(0, -1);
const int MAXN = 305, MAXL = 305;

int n, m, l;
char field[MAXN][MAXN];
char s[MAXL];
vector<int> now;
int used[MAXN][MAXN][MAXL];

int dx[4] = {1, 0, -1, 0};
int dy[4] = {0, 1, 0, -1};

int dfs(int x, int y, int z) {
    //cerr << x << " " << y << " " << z << endl;
    //cerr << v << endl;
    used[x][y][z] = 1;
    now.puba((x * m + y) * l + z);
    for (int d = 0; d < 4; ++d) {
        int nx = x + dx[d];
        int ny = y + dy[d];
        int nz = (z + 1);
        if (nz == l) {
            nz = 0;
        }
        if (0 <= nx && nx < n && 0 <= ny && ny < m && s[nz] == field[nx][ny]) {
            if (!used[nx][ny][nz]) {
                dfs(nx, ny, nz);
            } else if (used[nx][ny][nz] == 1) {
                reverse(bend(now));
                //cerr << szof(now) << endl;
                int to = (nx * m + ny) * l + nz;
                while (now.back() / l / m != nx || now.back() / l % m != ny) {
                    now.pop_back();
                }
                //cerr << szof(now) << endl;
                reverse(bend(now));
                int pos = -1;
                for (int i = 0; i < szof(now); ++i) {
                    //cerr << now[i] % l << endl;
                    if (now[i] % l == 0) {
                        pos = i;
                        break;
                    }
                }
                assert(pos != -1);
                rotate(now.begin(), now.begin() + pos, now.end());
                cout << "YES\n" << szof(now) << "\n";
                int prevx = now[0] / l / m;
                int prevy = now[0] / l % m;
                cout << prevx + 1 << " " << prevy + 1 << "\n";
                

                now.puba(now[0]);
                for (int i = 1; i < szof(now); ++i) {
                    int nextx = now[i] / l / m;
                    int nexty = now[i] / l % m;
                    if (nextx < prevx) {
                        cout << "U";
                    } else if (nextx > prevx) {
                        cout << "D";
                    } else if (nexty < prevy) {
                        cout << "L";
                    } else {
                        cout << "R";
                    }
                    prevx = nextx;
                    prevy = nexty;
                }
                cout << "\n";
                exit(0);
            }
        }
    }
    used[x][y][z] = 2;
    now.pop_back();
    return 0;
}

string zip(string s) {
    vector<int> z(szof(s));

    int lg = 0, rg = 0;
    for (int i = 1; i < szof(s); ++i) {
        if (rg > i) {
            z[i] = min(rg - i, z[i - lg]);
        }
        while (z[i] + i < szof(s) && s[z[i]] == s[i + z[i]]) {
            ++z[i];
        }

        if (z[i] + i == szof(s) && z[i] % i == 0) {
            s.resize(i);
            return s;
        }

        if (rg < i + z[i]) {
            rg = i + z[i];
            lg = i;
        }
    }
    return s;
}

int main() {
    //freopen(TASK_NAME ".in", "r", stdin);
    //freopen(TASK_NAME ".out", "w", stdout);

    scanf("%d%d%d", &n, &m, &l);

    for (int i = 0; i < n; ++i) {
        scanf("%s", field[i]);
    }

    scanf("%s", s);
    
    string tmp = zip(s);

    for (int i = 0; i < szof(tmp); ++i) {
        s[i] = tmp[i];
    }

    s[szof(tmp)] = 0;
    l = szof(tmp);

    int tot = n * m * l;
    //graph.resize(tot);
    //used.resize(tot);

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (!used[i][j][0] && field[i][j] == s[0]) {
                dfs(i, j, 0);
            }
        }
    }

    cout << "NO\n";

    #ifdef LOCAL
        cerr << "time: " << clock() << endl;
    #endif
    return 0;
}